   function [fy,C]=fpidfuns(x,G,t,key,type)
   s=fotf('s');
   switch type
      case 'fpid', C=x(1)+x(2)*s^(-x(4))+x(3)*s^(x(5));
      case 'fpi', C=x(1)+x(2)*s^(-x(3));
      case 'fpd', C=x(1)+x(2)*s^x(3);
      case 'fpidx', C=x(1)+x(2)/s+x(3)*s^x(4);
      case {'pid','PID'}, C=x(1)+x(2)/s+x(3)*s;
   end
   dt=t(2)-t(1); y=step(feedback(G*C,1),t); e=1-y;
   switch key
      case {'itae','ITAE'}, fy=dt*sum(t.*abs(e));
      case {'ise','ISE'}, fy=dt*sum(e.^2);
      case {'iae','IAE'}, fy=dt*sum(abs(e));
      case {'itse','ITSE'}, fy=dt*sum(t.*e.^2);
      otherwise, error('Error: available criteria are itae, ise, iae, itse.')
   end
   disp([x fy])
