function varargout = optimfopid(varargin)
% OPTIMFOPID MATLAB code for optimfopid.fig
% See also: FPIDTUNE

% Designed by Professor Dingyu Xue
% Northeastern University
% Shenyang 110004, China
% email: xuedingyu@mail.neu.edu.cn

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @optimfopid_OpeningFcn, ...
                   'gui_OutputFcn',  @optimfopid_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before optimfopid is made visible.
function optimfopid_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
guidata(hObject, handles);

function varargout = optimfopid_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

function hLstController_Callback(hObject, eventdata, handles)
function hLstController_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function hLstCriterion_Callback(hObject, eventdata, handles)
function hLstCriterion_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function hBtnResponse_Callback(hObject, eventdata, handles)
G=get(handles.hBtnPlant,'UserData');
Gc=get(handles.hBtnResponse,'UserData');
t=eval(get(handles.hEdtTerminate,'String'));
if length(t)==1, t=0:t/100:t; end
axes(handles.hAxisMain); 
kHold=get(handles.hChkHold,'Value'); 
if kHold==1, hold on; else; hold off; end
step(feedback(G*Gc,1),t);


function hEdtTerminate_Callback(hObject, eventdata, handles)
function hEdtTerminate_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function hLstAlgorithm_Callback(hObject, eventdata, handles)
function hLstAlgorithm_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function hEdtUpper_Callback(hObject, eventdata, handles)
function hEdtUpper_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function hEdtLower_Callback(hObject, eventdata, handles)
function hEdtLower_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function hChkHold_Callback(hObject, eventdata, handles)

function hBtnPlant_Callback(hObject, eventdata, handles)
G=evalin('base','G'); set(handles.hBtnPlant,'UserData',G);

function hBtnOptimize_Callback(hObject, eventdata, handles)
kAlgorithm=get(handles.hLstAlgorithm,'Value');
kController=get(handles.hLstController,'Value');
xm=eval(get(handles.hEdtLower,'String')); 
if length(xm)==1, xm=xm*[1,1,1]; end 
xM=eval(get(handles.hEdtUpper,'String')); 
if length(xM)==1, xM=xM*[1,1,1]; end 
switch kController
    case 1, con='fpid'; num_pars=5; xm(4:5)=0; xM(4:5)=1.8;
    case 2, con='fpi'; num_pars=3; xm(3)=0; xM(3)=1.8;
    case 3, con='fpd'; num_pars=3; xm(3)=0; xM(3)=1.8;
    case 4, con='fpidx'; num_pars=4; xm(4)=0; xM(4)=1.8;
    case 5, con='pid'; num_pars=3;
end
y0=1e10; y=1e8;
key=get(handles.hLstCriterion,'Value');
switch key
    case 1, key0='itae';
    case 2, key0='ise';
    case 3, key0='iae';
    case 4, key0='itse';
end
G=get(handles.hBtnPlant,'UserData');
t=eval(get(handles.hEdtTerminate,'String')); 
if length(t)==1, t=0:t/100:t; end
x0=mean([xm;xM]);
while (1)
   [Gc,x,y]=fpidtune(G,con,t,key0,x0,xm,xM); 
   if abs(y-y0)>1e-3, y0=y; x0=x; else, break; end
end
set(handles.hBtnResponse,'UserData',Gc); assignin('base','Gc',Gc)
