function [Gc,Kp,Ti,Td]=ziegler(key,vars)
switch length(vars)
   case 3,
      K=vars(1); Tc=vars(2); N=vars(3);
      if key==1, Kp=0.5*K; Ti=inf; Td=0;
      elseif key==2, Kp=0.4*K; Ti=0.8*Tc; Td=0;
      elseif key==3, Kp=0.6*K; Ti=0.5*Tc; Td=0.12*Tc; end
   case 4
      K=vars(1); L=vars(2); T=vars(3); N=vars(4); a=K*L/T;
      if key==1, Kp=1/a; Ti=inf; Td=0;
      elseif key==2, Kp=0.9/a; Ti=3*L; Td=0;
      elseif key==3, Kp=1.2/a; Ti=2*L; Td=L/2; end
   case 5,
      K=vars(1); Tc=vars(2); rb=vars(3); N=vars(5);
      pb=pi*vars(4)/180; Kp=K*rb*cos(pb);
      if key==2, Ti=-Tc/(2*pi*tan(pb)); Td=0;
      elseif key==3, Ti=Tc*(1+sin(pb))/(pi*cos(pb)); Td=Ti/4;
end, end
Gc=pidstd(Kp,Ti,Td,N);